#include "TLC59116.h"
#include "I2C wrapper.h"



void	drv_TLC59116_init(void){
	/*	Initialize i2c bus																					*/

		nrf_gpio_range_cfg_output(22, 23);

		nrf_gpio_pin_write(22, 1);

		nrf_gpio_pin_write(23, 1);
	
	
	/*	Initialize mode regiters																		*/
		twi_sendCommand(IC_RED_ARRAY, REG_MODE1, 0x00, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_MODE2, MODE2_BLNK, 2);

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_MODE1, 0x00, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_MODE2, MODE2_BLNK, 2);	
	
	/*	Initialize LED brightness such that brightness is off				*/
	
	
	
	/*	Initialize registers such that individual brightness and 
			group dimming/blinking can be controlled through its PWMx
			register and the GRPPWM registers.													*/
	
		
	
};


bool	drv_TLC59116_set_LED(uint8_t color, uint8_t LEDnumber , uint8_t brightness){

	twi_sendCommand(color, LEDnumber, brightness, 1);
	
	return true;
};

bool	drv_TLC59116_group_dim(uint8_t color, uint8_t brightness){

	twi_sendCommand(color, REG_GRPFREQ, brightness, 1);	
	
	return true;
};

bool 	drv_TLC59116_set_group_freq(uint8_t color, uint8_t freq){
	
	twi_sendCommand(color, REG_GRPFREQ, freq, 1);
	
	return true;
};

int		drv_TLC59116_get_LED_brightness(uint8_t color, uint8_t LED){
	
	//DO SOMETHING - I'M GIVING UP ON YOU
	
	return 0;
};

bool	drv_TLC59116_red_flash_rapid(void){

	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, LEDOUT_PWM_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, LEDOUT_PWM_GRPPWM, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, LEDOUT_PWM_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM0, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM1, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM2, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM3, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM4, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM5, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM6, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM7, PWM_HALF, 2);		

		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_IREF_RW, RED_IREF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_GRPFREQ, FLASH_RAPID, 2);

		twi_sendCommand(IC_RED_ARRAY, REG_GRPPPWM, 0xA0,2);
		return true;

};

bool			drv_TLC59116_red_solid(void){
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM0, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM1, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM2, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM3, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM4, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM5, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM6, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM7, PWM_MAX, 2);		

		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_MAX, 2);
		
//		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM12, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_IREF_RW, RED_IREF, 2);
		
		return true;

};

bool			drv_TLC59116_red_off(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, 0x00, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, 0x00, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0x00, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x55, 2);
	
		return true;

};

bool			drv_TLC59116_blue_solid(void){

	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT2, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM0, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM1, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM2, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM3, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM4, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM5, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM6, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM7, PWM_MAX, 2);		

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM8, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM9, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM10, PWM_MAX, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM11, PWM_MAX, 2);
		
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_IREF_RW, BLUE_IREF, 2);
		
		return true;

};

bool			drv_TLC59116_blue_off(void){
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, 0x00, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, 0x00, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT2, 0x00, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x00, 2);
	
		return true;

};

bool			drv_TLC59116_red_sides_flash(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, 0xD5, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, 0x57, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0x7D, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x55, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM0, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM1, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM2, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM3, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM4, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM5, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM6, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM7, PWM_MAX, 2);		

		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_MAX, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_MAX, 2);

		return true;
};

bool 			drv_TLC59116_red_sides_off(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, 0x15, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, 0x54, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0x42, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x55, 2);
	
		return true;
		

};

bool			drv_TLC59116_red_Q_on(void){
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x01, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM12, PWM_MAX, 2);

		return true;
};

bool			drv_TLC59116_red_Q_off(void){
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x00, 2);

		return true;

};

bool			drv_TLC59116_blue_Q_on(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x01, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM12, PWM_MAX, 2);
	
		return true;
};

bool			drv_TLC59116_blue_Q_off(void){
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x00, 2);
	
		return true;

};

bool			drv_TLC59116_green_Q_on(void){
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x04, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM13, PWM_MAX, 2);
	
		return true;

};

bool			drv_TLC59116_green_Q_off(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x00, 2);
	
		return true;
	
};

bool			drv_TLC59116_yellow_Q_on(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x50, 2);
	
		return true;
	
};
bool			drv_TLC59116_yellow_Q_off(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x00, 2);
		
		return true;
	
};

bool			drv_TLC59116_off(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, 0x00, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, 0x00, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0x00, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x00, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, 0x00, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, 0x00, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT2, 0x00, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, 0x00, 2);
	
		return false;

};

uint16_t	drv_TLC59116_get_errors(void){
	
/****************************************************************
* read EFLAG1; read EFLAG2; OR result; return result
*****************************************************************/
	
	
	
	return 0;
}; 

bool			drv_TLC59116_red_dim(void) {

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT0, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT1, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM0, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM1, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM2, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM3, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM4, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM5, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM6, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM7, PWM_HALF, 2);		

		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_HALF, 2);
		
		
		twi_sendCommand(IC_RED_ARRAY, REG_IREF_RW, DIM_IREF, 2);
		
		return true;


}

bool			drv_TLC59116_blue_dim(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT2, LEDOUT_PWM_NO_GRPPWM, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT3, LEDOUT_PWM_NO_GRPPWM, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM0, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM1, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM2, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM3, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM4, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM5, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM6, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM7, PWM_HALF, 2);		

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM8, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM9, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM10, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM11, PWM_HALF, 2);
		
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_IREF_RW, DIM_IREF, 2);
		
		return true;



}

bool			drv_TLC59116_red_Q_dim(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT3, 0x01, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM12, PWM_HALF, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_IREF_RW, DIM_IREF, 2);
	
		return true;

}

bool			drv_TLC59116_blue_cal_flash(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, 0xF0, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, 0x0f, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM2, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM3, PWM_HALF, 2);	
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM4, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM5, PWM_HALF, 2);		
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_GRPFREQ, FLASH_RAPID, 2);
	
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_GRPPPWM, 0xA0,2);
	
		return true;

}

bool			drv_TLC59116_red_cal_flash(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0xFF, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_HALF, 2);	
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_HALF, 2);		
	
		twi_sendCommand(IC_RED_ARRAY, REG_GRPFREQ, FLASH_RAPID, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_GRPPPWM, 0xA0,2);
	
		return true;

}

bool			drv_TLC59116_blue_cal_solid(void){

		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT0, 0x50, 2);
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_LEDOUT1, 0x05, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM2, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM3, PWM_HALF, 2);	
	
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM4, PWM_HALF, 2);
		
		twi_sendCommand(IC_BLUE_GREEN_ARRAY, REG_PWM5, PWM_HALF, 2);		
	
		return true; 

}

bool			drv_TLC59116_red_cal_solid(void){

		twi_sendCommand(IC_RED_ARRAY, REG_LEDOUT2, 0x55, 2);
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM8, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM9, PWM_HALF, 2);	
	
		twi_sendCommand(IC_RED_ARRAY, REG_PWM10, PWM_HALF, 2);
		
		twi_sendCommand(IC_RED_ARRAY, REG_PWM11, PWM_HALF, 2);		
	
		return true;

}



