#include "I2C wrapper.h"
#include "SEGGER_RTT.h"

extern const nrf_drv_twi_t I2C_twi_master;

/* Indicates if operation on TWI has ended. */
extern volatile bool mTWI_xfer_done;
//extern volatile bool //mTWI_xfer_error;

bool I2Cbus_init(void) {
    bool bus_clear = false;

    // data line
    if (nrf_gpio_pin_read(nRF_PERIPH_MASTER_I2C_SDA) == 1) {
        bus_clear = true;
        //SEGGER_RTT_printf(0, "I2C Bus clear\r\n");
    }

    // clock line
    if (nrf_gpio_pin_read(nRF_PERIPH_MASTER_I2C_SCL) == 1) {
        bus_clear = true;
        //SEGGER_RTT_printf(0, "I2C Bus clear\r\n");
    }

    //twi_clear_bus(&I2C_twi_master, 0);

    return bus_clear;
}


bool twi_sendCommand(uint8_t ptrDevice,  uint8_t registerAddr,  uint8_t registerVal, uint8_t numBytes) {
    //
    uint32_t volatile err_code;
    uint32_t debug_code;
    uint8_t index = 0;
    bool nostop = false;

    mTWI_xfer_done = false;
    //mTWI_xfer_error = false;

    uint8_t m_txbuf[2] = { 0x00, 0x00 };                  //, 0x00
/*
    if ((numBytes > 1) && (ptrDevice != 0x40)) {
        nostop = true;
    } else {
        nostop = false;
    }
*/
    m_txbuf[index++] = registerAddr;

    if (registerVal != NULL) {
        m_txbuf[index++] = registerVal;
    }

    if (numBytes < 255) {
        //uint8_t address, const uint8_t *p_data, uint8_t length, bool no_stop
        err_code = nrf_drv_twi_tx(&I2C_twi_master, ptrDevice, m_txbuf, sizeof(m_txbuf), nostop);
        if (err_code != NRF_SUCCESS) {
            debug_code = 0;
            debug_code = 0;
            debug_code = 0;
            return false;
        }
    }

    debug_code = 0;
    debug_code = 0;
    debug_code = 0;

  /*
    while (mTWI_xfer_done == false) {
        //if any I2C bus error detected then we will terminate waiting
        if (mTWI_xfer_error == true) {
            debug_code = 0;
            debug_code = 0;
            break;
        }
    }
  */
		while (mTWI_xfer_done == false) {
				
		}


    debug_code = 0;
    debug_code = 0;
    debug_code = 0;
    return true;
}

bool twi_readDevice(uint8_t ptrDevice, uint8_t *buffer, uint8_t numBytes, bool continuous) {
    //
    uint32_t volatile err_code;
    uint32_t debug_code;
    uint32_t volatile recvdByteCnt;

    //mTWI_xfer_done = false;
    //mTWI_xfer_error = false;

    if (numBytes < 255) {
        err_code = nrf_drv_twi_rx(&I2C_twi_master, ptrDevice, buffer, numBytes);                            // 
        APP_ERROR_CHECK(err_code);
    }

    debug_code = 0;
    debug_code = 0;
    debug_code = 0;

		/*
    while (mTWI_xfer_done == false) {
        debug_code = 0;
        debug_code = 0;
        debug_code = 0;
        //if any I2C bus error detected then we will terminate waiting
        if (mTWI_xfer_error == true) {
            debug_code = 0;
            debug_code = 0;
            debug_code = 0;
            break;
        }
    }
		*/

    debug_code = 0;
    debug_code = 0;
    debug_code = 0;
    return true;
}

uint8_t* twi_readContinous(uint8_t ptrDevice, const uint8_t *registerAddr, uint8_t *buffer, uint8_t TXnumBytes, uint8_t RXnumBytes) {
    //
    uint8_t m_txbuf[3] = { 0x00, 0x00, 0x00 };                  //
    uint8_t index = 0;
    //
    uint32_t volatile err_code;
    uint32_t debug_code;
    uint32_t volatile recvdByteCnt;

    //mTWI_xfer_error = false;

    static uint8_t rxBuffer[32];

    debug_code = 0;
    debug_code = 0;
    debug_code = 0;
    memset(&rxBuffer, 0, sizeof(rxBuffer));

    m_txbuf[index++] = *registerAddr;

    if (TXnumBytes < 255) {
        //
        err_code = 0;
        err_code = 0;
        err_code = 0;
        //mTWI_xfer_done = false;
        //uint8_t address, const uint8_t *p_data, uint8_t length, bool no_stop
        err_code = nrf_drv_twi_tx(&I2C_twi_master, ptrDevice, m_txbuf, TXnumBytes, true);

        debug_code = 0;
        debug_code = 0;
        debug_code = 0;

			/*
        while (mTWI_xfer_done == false) {
            //if any I2C bus error detected then we will terminate waiting
            if (mTWI_xfer_error == true) {
                debug_code = 0;
                debug_code = 0;
                break;
            }
        }
			*/

        //if (1) {         //ptrDevice == 0x40
        nrf_delay_us(40);
        //}

        err_code = 0;
        err_code = 0;
        err_code = 0;
        //mTWI_xfer_done = false;
        //uint8_t address, uint8_t *p_data, uint8_t length
        err_code = nrf_drv_twi_rx(&I2C_twi_master, ptrDevice, rxBuffer, RXnumBytes);

        debug_code = 0;
        debug_code = 0;
        debug_code = 0;

				/*
        while (mTWI_xfer_done == false) {
            //if any I2C bus error detected then we will terminate waiting
            if (mTWI_xfer_error == true) {
                debug_code = 0;
                debug_code = 0;
                break;
            }
        }
				*/
    }

    debug_code = 0;
    debug_code = 0;
    debug_code = 0;
    return rxBuffer;
}
